<%
'*****************************************************
' peetan is licensed under the MIT license.
' copyright (c) 2007 peetan all right reserved.
' http://peetan.cre8labs.com/
'*****************************************************
%>
<%
Class Database

	Public config
	Public connection
	Public driver


	' RXgN^
	Public Sub Class_Initialize()

		Set Me.config = CreateDictionary()
		Set Me.connection = CreateDictionary()
 		Set Me.driver = CreateDictionary()

	End Sub


	Public Sub add(name, dsn, dbtype)

		Dim conf
		
		Set conf = CreateDictionary()
		conf.Add "dsn", dsn
		conf.Add "type", dbtype
	
		Me.config.Add name, conf
		
	End Sub
	
	
	Public Function connect(name)
	
		Dim conf
		Dim conn
		
		Set conf = Me.config(name)
		
		Set conn = CreateObject("ADODB.Connection")
		conn.Open conf("dsn")
		
		Me.connection.Add name, conn
		
	End Function


	Public Function GetDriver(name)
	
		If Me.connection.Exists(name) = False Then
			Me.connect(name)
		End If
		If Me.driver.Exists(name) = False Then
			Dim db
			Dim conf
			Set conf = Me.config(name)
			Set db = New AdoDB
			db.db_type = conf("type")
			Me.driver.Add name, db
		End If
		
		Set GetDriver = Me.driver(name)
	
	End Function


	Public Function query(sql, name)
	
		Dim d
		
		Set d = Me.GetDriver(name)
		Set query = d.query(sql, Me.connection(name))
		
	End Function
	
	
	Public Function findquery(sql, condition, order, limit, group, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set findquery = d.findquery(Me.connection(name), sql, condition, order, limit, group)
		
	End Function
	
	
	Public Function findall(table, condition, order, limit, group, name)
	
		Dim d
		
		Set d = Me.GetDriver(name)
		Set findall = d.findall(Me.connection(name), table, condition, order, limit, group)
		
	End Function
	
	
	Public Function find(sql, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set find = d.find(sql, Me.connection(name))
		
	End Function
	
	
	Public Function count(sql, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set count = d.count(sql, Me.connection(name))
		
	End Function
	
	
	Public Function insert(table, datas, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set insert = d.insert(table, datas, Me.connection(name))
		
	End Function
	
	
	Public Function getcount(table, condition, limit, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		getcount = d.getcount(Me.connection(name), table, condition, limit)
		
	End Function
	
	
	Public Function update(table, datas, condition, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set update = d.update(table, datas, condition, Me.connection(name))
		
	End Function
	
	
	Public Function del(table, condition, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set del = d.del(table, condition,Me.connection(name))
		
	End Function
	
	
	Public Function CreateCondition(field, value, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		CreateCondition = d.CreateCondition(field, value)
		
	End Function
	
	
	Public Function escape(str, name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set escape = d.escape(str)
		
	End Function
	
	
	Public Function GetLastInsertId(name)

		Dim d
		
		Set d = Me.GetDriver(name)
		Set GetLastInsertId = d.GetLastInsertId()
		
	End Function
	
	
End Class
%>
